import type { CropperOptions } from 'cropperjs';
import Cropper from 'cropperjs';
import type { SetNonNullable } from 'type-fest';
export interface PassThroughOptions {
    /**
     * The new Cropper() class construction
     */
    cropper?: {
        constructOptions?: CropperOptions;
    };
    /**
     * The cropper-image element
     */
    image?: {
        attributes?: Partial<ReturnType<Cropper['getCropperImage']> & {
            class: string;
        }>;
    };
    /**
     * The cropper-canvas element
     */
    canvas?: {
        attributes?: Partial<ReturnType<Cropper['getCropperCanvas']> & {
            class: string;
        }>;
    };
    /**
     * The (first) cropper-selection element
     */
    selection?: {
        attributes?: Partial<ReturnType<Cropper['getCropperSelection']> & {
            class: string;
        }>;
    };
    /**
     * All cropper-selection elements
     */
    selections?: {
        attributes?: Partial<ReturnType<Cropper['getCropperSelection']> & {
            class: string;
        }>;
    };
}
declare const cropperKeys: {
    cropper: Cropper | undefined;
    image: import("cropperjs").CropperImage | null | undefined;
    canvas: import("cropperjs").CropperCanvas | null | undefined;
    selection: import("cropperjs").CropperSelection | null | undefined;
    selections: NodeListOf<import("cropperjs").CropperSelection> | null | undefined;
};
type MountedCropperKeys = SetNonNullable<typeof cropperKeys>;
type CropperHook = (cropperKeys: MountedCropperKeys) => any;
declare function onCropperMounted(hook: CropperHook): void;
declare const _default: import("vue").DefineComponent<__VLS_TypePropsToOption<{
    id?: string;
    src?: string;
    crossorigin?: "anonymous" | "use-credentials";
    /**
     * Automatically call $reset() on initial attributes changes
     * @default true
     */
    resetOnInitialAttributes?: boolean;
    passThrough?: PassThroughOptions;
}>, {
    onCropperMounted: typeof onCropperMounted;
    cropperMounted: false;
    cropper: Cropper | undefined;
    image: import("cropperjs").CropperImage | null | undefined;
    canvas: import("cropperjs").CropperCanvas | null | undefined;
    selection: import("cropperjs").CropperSelection | null | undefined;
    selections: NodeListOf<import("cropperjs").CropperSelection> | null | undefined;
} | {
    onCropperMounted: typeof onCropperMounted;
    cropperMounted: true;
    cropper: Cropper;
    image: import("cropperjs").CropperImage;
    canvas: import("cropperjs").CropperCanvas;
    selection: import("cropperjs").CropperSelection;
    selections: NodeListOf<import("cropperjs").CropperSelection>;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<__VLS_TypePropsToOption<{
    id?: string;
    src?: string;
    crossorigin?: "anonymous" | "use-credentials";
    /**
     * Automatically call $reset() on initial attributes changes
     * @default true
     */
    resetOnInitialAttributes?: boolean;
    passThrough?: PassThroughOptions;
}>>>, {}, {}>;
export default _default;

type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToOption<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
